﻿Type=Class
Version=5.82
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private fx As JFX
	Private thisDoc As JavaObject
	Private renderer As JavaObject
	Private utils As JavaObject
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize As Object
	'create a new document
	thisDoc.InitializeNewInstance("org.apache.pdfbox.pdmodel.PDDocument",Null)
	renderer.InitializeNewInstance("org.apache.pdfbox.rendering.PDFRenderer",Array(thisDoc))
	utils.InitializeStatic("javafx.embed.swing.SwingFXUtils")
	Return thisDoc 
End Sub
Sub newPage As JavaObject
	Dim thisPage As JavaObject
	Dim a4 As JavaObject
	a4.InitializeStatic("org.apache.pdfbox.pdmodel.common.PDRectangle")
	thisPage.InitializeNewInstance("org.apache.pdfbox.pdmodel.PDPage",Array(a4.GetFieldJO("A4")))
	Return thisPage
End Sub
Sub addPage(doc As JavaObject,page As JavaObject)
	thisDoc.RunMethod("addPage",Array(page))
End Sub
Sub addTextTo(page As JavaObject,text() As String)
	Dim content As JavaObject
	Dim pdfont,pdfonttype As JavaObject
	Dim pageSize As JavaObject
	pdfonttype.InitializeStatic("org.apache.pdfbox.pdmodel.font.PDType1Font")
	pdfont = pdfonttype.GetFieldJO("TIMES_ROMAN")
	content.InitializeNewInstance("org.apache.pdfbox.pdmodel.PDPageContentStream",Array(thisDoc,page))
	pageSize = page.RunMethod("getMediaBox",Null)
	Dim top As Float = pageSize.RunMethod("getHeight",Null)
	content.RunMethod("beginText",Null)
	content.RunMethod("setFont",Array(pdfont,16.0f))
	content.RunMethod("setLeading",Array(16.0d))
	content.RunMethod("newLineAtOffset",Array(20.0f,top - 20.0f))
	For Each line As String In text
		line = line.Replace(TAB,"   ")
		content.RunMethod("showText",Array(line))
		content.RunMethod("newLine",Null)
	Next
	content.RunMethod("endText",Null)
	content.RunMethod("close",Null)
End Sub
Sub print()
	callJava(Me,"doPrint",Array(thisDoc))
End Sub
Sub callJava(owner As JavaObject,Method As String,params() As Object)
	owner.RunMethod(Method,params)
End Sub
Sub saveDocument(name As String)
	thisDoc.RunMethod("save",Array(name))
	thisDoc.RunMethod("close",Null)
End Sub
Sub renderPage(p As Int) As Image
	Dim scrn As JavaObject
	Dim dpi As Float = scrn.InitializeStatic("javafx.stage.Screen").RunMethodJO("getPrimary",Null).RunMethod("getDpi",Null)
	Return utils.RunMethodjo("toFXImage",Array(renderer.RunMethod("renderImageWithDPI",Array(p,dpi)),Null))
End Sub
#if java
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.io.File;
import java.io.IOException;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.printing.PDFPageable;

public void doPrint(PDDocument doc) throws IOException, PrinterException {
    try {
      PrinterJob job = PrinterJob.getPrinterJob();
      job.setPageable(new PDFPageable(doc));
      job.print();
    } catch (Exception e) {
      System.out.println(e);
    }
  }

#end if